#include "SFXML.H"


void	SFTokenBuilder::Create()
{
	m_LastErrorCode = EC_NOERROR;
	m_vTokenNode.reserve(100);
	m_bUseQutationMark=true;
	m_iCurrentParsePos=0;
	m_iCurrentParseLine=0;
	m_iCurrentParseColumn=0;
	m_bNowFindEndQutation=false;
	m_iFindEndQutationStartLine=0;
	m_iFindEndQutationStartColumn=0;

    AddSeperator(' ');
    AddSeperator('\n');
    AddSeperator('\t');
    AddSeperator('<');
    AddSeperator('>');
    AddSeperator('(');
    AddSeperator(')');
    AddSeperator('\"');
    AddSeperator('=');
    AddSeperator(',');

    AddIgnoreChar('\n');
    AddIgnoreChar('\t');
    AddIgnoreChar('\"');
    AddIgnoreChar(' ');
}
void	SFTokenBuilder::Destroy()
{
}
bool SFTokenBuilder::BuildTokenFromFile(char* Filename)	//	Ƽ  ϴ κ
{
    CFileResource	FileRes;
	FileRes.SetFileName(Filename);
	if(!FileRes.LoadResource())
	{
        SetLastErrorCode(EC_FILEREADERROR);
	}
    
    if (BuildTokenFromBuffer(FileRes) == false) {
        ODS("BuildTokenFromBuffer Failed, File : %s",Filename);
        SetLastErrorCode(EC_BUILDTOKENFAILED);
        return false;
    }

    SetLastErrorCode(EC_NOERROR);
	return	true;
}
bool SFTokenBuilder::BuildTokenFromBuffer(CFileResource &FileRes)
{
    //ODS("Build Token Start\n");
    if(FileRes.GetBufferLength() == 0) return false;

    m_vTokenNode.clear();

    stTokenNode Token("",0,0);

    m_iCurrentParsePos = 0;
    m_iCurrentParseLine = 0;
    m_iCurrentParseColumn = 0;
    m_bNowFindEndQutation = false;

	while(true)
	{
		if(!GetNextToken(FileRes,Token)) break;
		if(strlen(Token.GetTokenName())==0) continue;
		m_vTokenNode.push_back(Token);
	
	}

    SetLastErrorCode(EC_NOERROR);
    //System.out.println("Build Token Success");
	return	true;
}
bool SFTokenBuilder::GetNextToken(CFileResource &FileRes,stTokenNode &ResultToken)
{
    if (m_iCurrentParsePos >= FileRes.GetBufferLength() ) return false;

    char Char[MAX_XML_TOKEN_NAME_LENGTH+1];
    char ResultTokenString[MAX_XML_TOKEN_NAME_LENGTH+1];
    bool bFirst = true;
    int iStartLine = m_iCurrentParseLine,iStartColumn = m_iCurrentParseColumn;

	ResultTokenString[0]='\0';
	char	*pBefore = (char*)FileRes.GetBuffer() + m_iCurrentParsePos;
	char	*pNext;
	int	iLength;
    while(true)
    {
		pNext = CharNext(pBefore);
        iLength = (DWORD)pNext-(DWORD)pBefore;
		memcpy(Char,pBefore,iLength);
		Char[iLength]='\0';

        if(m_bNowFindEndQutation && IsQutationMark(Char))
        {
            m_bNowFindEndQutation = false;

            m_iCurrentParsePos+=iLength;
            m_iCurrentParseColumn+=iLength;

			ResultToken.SetToken(ResultTokenString,iStartLine,iStartColumn);
            return true;
        }

        if(!m_bNowFindEndQutation && IsSeperator(Char))
        {
            if(GetUseQutationMark() && IsQutationMark(Char))
            {
                m_bNowFindEndQutation = true;

                m_iFindEndQutationStartLine = iStartLine;
                m_iFindEndQutationStartColumn = iStartColumn;

                m_iCurrentParsePos+=iLength;
                m_iCurrentParseColumn+=iLength;

                ResultToken.SetToken(ResultTokenString,iStartLine,iStartColumn);
             }
            else
            {
                if(bFirst)
                {
                    if(IsIgnoreChar(Char) == false)  strcat(ResultTokenString,Char);
                    m_iCurrentParsePos+=iLength;

                    ResultToken.SetToken(ResultTokenString,iStartLine,iStartColumn);
                    if(iLength == 1 && Char[0] == '\n' )// new line
                    {
                        m_iCurrentParseLine ++;
                        m_iCurrentParseColumn =0;
                    }
                    else
                    {
                        m_iCurrentParseColumn+=iLength;
                    }
                }
                else
                {
                    ResultToken.SetToken(ResultTokenString,iStartLine,iStartColumn);
                }
            }
            return true;
        }

        if(m_bNowFindEndQutation || IsIgnoreChar(Char) == false)
        {
            if(iLength == 1 && Char[0] == '\\' )
            {
                m_iCurrentParsePos+=iLength;
                m_iCurrentParseColumn+=iLength;
                if(m_iCurrentParsePos == FileRes.GetBufferLength()-1) break;

				pBefore = pNext;

				pNext = CharNext(pBefore);
				iLength = (DWORD)pNext-(DWORD)pBefore;
				memcpy(Char,pBefore,iLength);
				Char[iLength]='\0';
            }
            strcat(ResultTokenString,Char);
        }

        m_iCurrentParsePos +=iLength;
        m_iCurrentParseColumn +=iLength;
        bFirst = false;

        if(m_iCurrentParsePos == FileRes.GetBufferLength()-1) break;

		pBefore = pNext;
    }

    if(m_bNowFindEndQutation)
    {
        ODS("SFTokenBuilder::GetNextToken() Error, Cannot Find End Qutation, Start Qutation Line : %d  Column : %d",m_iFindEndQutationStartLine ,m_iFindEndQutationStartColumn);
    }

    ResultToken.SetToken(ResultTokenString,iStartLine,iStartColumn);

	return	true;
}

/////////////////////////////////////////////////////////////////////////////

SFXMLContent* SFXMLParser::ParseXMLFile(char* FileName)
{
	if(m_pTokenBuilder) delete m_pTokenBuilder;
    m_pTokenBuilder = new SFTokenBuilder();
    if(m_pTokenBuilder->BuildTokenFromFile(FileName) == false)
    {
        ODS("Build Token From File Failed. ErrorCode : %d\n",m_pTokenBuilder->GetLastErrorCode());
        SetLastErrorCode(EC_BUILDTOKENFAILED);
        return NULL;
    }

    // System.out.println("Build Token From File Success");

    // Builder.PrintContentToDebugTab();

    SFXMLContent *pXMLContent = new SFXMLContent();
    if(BuildXMLContentStart(pXMLContent)==false)
    {
		delete m_pTokenBuilder;
		m_pTokenBuilder = NULL;

		delete pXMLContent;
        SetLastErrorCode(EC_BUILDXMLCONTENTFAILED);
        return NULL;
    }

	PrintContentToDebugTab(pXMLContent);

	delete m_pTokenBuilder;
	m_pTokenBuilder = NULL;

    SetLastErrorCode(EC_NOERROR);
    return pXMLContent;
}
bool SFXMLParser::BuildXMLContentStart(SFXMLContent *pDestXMLContent)
{
    m_iNextTokenNumber = 0;

    // xml header decoding
    if(!DecodeXMLHeader(pDestXMLContent))
    {
        SetLastErrorCode(EC_DECODEXMLHEADERFAILED);
        return false;
    }

    SFXMLContentData *pContentData = pDestXMLContent->GetContentData();
    if(!DecodeContentData(pContentData))
    {
        SetLastErrorCode(EC_DECODECONTENTDATAFAILED);
        return false;
    }

    return true;
}
bool SFXMLParser::DecodeContentData(SFXMLContentData *pDestContentData) // recursive method
{

	int iResult = DecodeContentDataHeader(pDestContentData);
	if(iResult == 0) return false;
	if(iResult == -1) return true;

	do
	{
		stTokenNode *pToken = GetNextToken();
		if(pToken->equals("<"))
		{
			char EndContentTokenName[MAX_XML_TOKEN_NAME_LENGTH+1];
			sprintf(EndContentTokenName,"/%s",pDestContentData->GetDataName());

			pToken = GetNextToken();
			if(pToken->equals(EndContentTokenName)) // End of current Content data
			{
				pToken = GetNextToken();
				if(pToken->equals(">"))
				{
					return true;
				}

				SetLastErrorCode(EC_DECODECONTENTDATAFAILED,pToken);
				return false;
			}
			m_iNextTokenNumber-=2;

			SFXMLContentData *pChildContent = pDestContentData->AddChildContent();
			if(!DecodeContentData(pChildContent))
			{
				SetLastErrorCode(EC_DECODECONTENTDATAFAILED);
				return false;
			}

			continue;
		}

		char	NewDataValue[MAX_XML_TOKEN_NAME_LENGTH+1];
		sprintf(NewDataValue,"%s%s",pDestContentData->GetDataValue(),pToken->GetTokenName());
		pDestContentData->SetDataValue(NewDataValue);

	}while(true);

	return true;
}
int SFXMLParser::DecodeContentDataHeader(SFXMLContentData *pDestContentData)
{
    stTokenNode *pToken;

    pToken = GetNextToken();
    if(pToken->equals("<")==false)
    {
        SetLastErrorCode(EC_DECODINGERROR,pToken);
        return 0;
    }
    pToken = GetNextToken(); // Content Data Name
    if(IsCorrectForContentDataName(pToken)==false)
    {
        return 0;
    }

    pDestContentData->SetDataName(pToken->GetTokenName());

    char AttributeName[MAX_XML_TOKEN_NAME_LENGTH+1],AttributeValue[MAX_XML_TOKEN_NAME_LENGTH+1];
    do
    {
        pToken = GetNextToken();
        if(pToken->equals(">")) break;
		if(pToken->equals("/"))
		{
			pToken = GetNextToken();
			if(pToken->equals(">"))
			{
				//	end of this content
				return -1;
			}

			SetLastErrorCode(EC_DECODINGERROR,pToken);
			return	0;
		};

        if(IsCorrectForContentDataName(pToken) == false)
        {
            return 0;
        }

        strcpy(AttributeName,pToken->GetTokenName());

        pToken = GetNextToken();
        if(pToken->equals("=")==false)
        {
            SetLastErrorCode(EC_DECODINGERROR,pToken);
            return 0;
        }

        pToken = GetNextToken();

        strcpy(AttributeValue,pToken->GetTokenName());

        pDestContentData->GetAttribute()->AddAttributeNode(AttributeName,AttributeValue);

    }while(true);

    return 1;
}
bool SFXMLParser::IsCorrectForContentDataName(stTokenNode *pToken)
{
    char RestrictedChar[] = {'<','>','='};
    for(int i=0;i<3;i++)
    {
		char	*pPrev = pToken->GetTokenName(),*pNext;
		int	iCharLength;
		while(true)
        {
			pNext = CharNext(pPrev);
			iCharLength = (DWORD)pNext-(DWORD)pPrev;
			if(iCharLength == 0) break;
			if(iCharLength == 1 && *pPrev==RestrictedChar[i])
            {
                SetLastErrorCode(EC_NOTCORRECTNAME,pToken);
                return false;
            }

			pPrev = pNext;
        }
    }
    return true;
}
bool SFXMLParser::DecodeXMLHeader(SFXMLContent *pDestXMLContent)
{
    float fVersion = 0;
    char CharSet[MAX_XML_TOKEN_NAME_LENGTH+1];
	strcpy(CharSet,"UTF-8");

    stTokenNode *pToken;
    int iTotalToken = m_pTokenBuilder->GetTotalTokenNumber();
    if (iTotalToken == 0) {
        SetLastErrorCode(EC_NOTXMLFILE);
        return false;
    }
    pToken = GetNextToken();
    if (pToken->equals("<") == false) {
        SetLastErrorCode(EC_NOTXMLFILE,pToken);
        return false;
    }
    pToken = GetNextToken();
    if (pToken->equals("?xml") == false){
        SetLastErrorCode(EC_NOTXMLFILE,pToken);
        return false;
    }


    do
    {

        pToken = GetNextToken();
        if(pToken->equals(">")) {
            break;
        }

        if(m_iNextTokenNumber==iTotalToken) {
            SetLastErrorCode(EC_DECODINGERROR);
            return false;
        }

        if(pToken->equals("version"))
        {
            pToken = GetNextToken();
            if(pToken->equals("=")==false)
            {
                SetLastErrorCode(EC_DECODINGERROR,pToken);
                return false;
            }
            pToken = GetNextToken();
            fVersion = pToken->GetTokenNameByFloat();

            continue;
        }
        if(pToken->equals("encoding"))
        {
            pToken = GetNextToken();
            if (pToken->equals("=") == false) {
                SetLastErrorCode(EC_DECODINGERROR,pToken);
                return false;
            }
            pToken = GetNextToken();
			strcpy(CharSet,pToken->GetTokenName());
        }
    }while(true);

    pDestXMLContent->SetEncodingCharSet(CharSet);
    pDestXMLContent->SetXMLVersion(fVersion);

    return true;
}
void SFXMLParser::PrintContentToDebugTab(SFXMLContent *pDestXMLContent)
{
        ODS("Data of current xml file\n");
        ODS("version : %f\n" ,pDestXMLContent->GetXMLVersion());
        ODS("charset : %s\n",pDestXMLContent->GetEncodingCharSet());
        ODS("Content Data\n");
        PrintContentToDebugTab(pDestXMLContent->GetContentData(),1);
}
void SFXMLParser::PrintContentToDebugTab(SFXMLContentData *pContentData,int iTabCount)
{
    if(pContentData==NULL) return;

	int i;

    char Tab[200] = "";
    for(i=0;i<iTabCount;i++)
    {
        strcat(Tab,"\t");
    }

	ODS("%sContent Name : %s\n",Tab,pContentData->GetDataName());
	ODS("%sContent Value : %s\n",Tab,pContentData->GetDataValue());
	ODS("%sTotal Attribute : %d\n",Tab,pContentData->GetAttribute()->GetTotalAttributeNodeNumber());
    for(i=0;i<pContentData->GetAttribute()->GetTotalAttributeNodeNumber();i++)
    {
		ODS("%sAttibute[%d] Name : %s Value : %s\n",Tab,i,pContentData->GetAttribute()->GetAttributeNode(i)->GetName(),pContentData->GetAttribute()->GetAttributeNode(i)->GetValue());
    }
    ODS("%sTotal Child : %d\n",Tab,pContentData->GetTotalChildNumber());

    for(i=0;i<pContentData->GetTotalChildNumber();i++)
    {
        PrintContentToDebugTab(pContentData->GetChildData(i),iTabCount+1);
    }
}
