#ifndef _DIRECTX_FOR_G1_TOOL_H
#define _DIRECTX_FOR_G1_TOOL_H

#include <d3d9.h>
#include <d3dx9.h>
#include <DxUtil.H>
#include "Singleton.H"
#include <d3dx9core.h>

#define MAX_TEXTUREFILENAME	100

struct TLVertex
{
    FLOAT    x, y, z, rhw;
    D3DCOLOR  diffuse;
};

#define D3DFVF_TLVERTEX  (D3DFVF_XYZRHW | D3DFVF_DIFFUSE)

//! ؽ Ŭ
/*!
ؽ  Ѵ.
*/
class	CTexture
{
	//! ؽ  ̸(Ϸκ ε ʾ ,  ڿ
	char m_strTextureFilename[MAX_TEXTUREFILENAME];

	//! D3D ؽ ̽ 
	LPDIRECT3DTEXTURE9	m_pTexture;	
	//!	 ؽ  
	int	m_iWidth,m_iHeight;	
	//!	û ؽ  
	int	m_iRequestedWidth,m_iRequestedHeight;	

public:
	//!  
	/*!
	  ʱȭѴ.
	*/
	CTexture()	{	m_pTexture=NULL;	m_iWidth=0;	m_iHeight=0;	m_iRequestedWidth=0; m_iRequestedHeight=0; }
	//! ı
	/*!
	ؽ ̽ Release Ų.
	*/
	~CTexture()	{	if(m_pTexture) m_pTexture->Release();	}

	//! ؽ ̽ Ѵ.
	LPDIRECT3DTEXTURE9	GetTexture()	{	return	m_pTexture;	}
	//! ؽ    Ѵ 
	int	GetWidth()	{	return	m_iWidth;	}
	//! ؽ    Ѵ.
	int	GetHeight()	{	return	m_iHeight;	}
	//! ؽ û   Ѵ.
	int	GetReqWidth()	{	return	m_iRequestedWidth;	}
	//! ؽ û   Ѵ.
	int	GetReqHeight()	{	return	m_iRequestedHeight;	}
	//! ؽ  ̸ Ѵ.
	char*	GetTextureFilename()	{	return	m_strTextureFilename;	}

	//!	ؽó  ̸ Ѵ.
	void	SetTextureFilename(char *strName)	{	strcpy(m_strTextureFilename,strName);	}
	//!  ؽĸ Release ϰ ο ؽĸ Ѵ.
	void	SetTexture(LPDIRECT3DTEXTURE9 pTexture)	{	Release(); m_pTexture=pTexture;	}
	//! ؽ   
	void	SetSize(int iWidth,int iHeight)	{	m_iWidth=iWidth;	m_iHeight=iHeight;	}
	//! ؽ û  
	void	SetReqSize(int iWidth,int iHeight)	{	m_iRequestedWidth=iWidth;	m_iRequestedHeight=iHeight;	}
	//! ؽ ̽ Release ϰ  Ѵ.
	void	Release()	{	if(m_pTexture) m_pTexture->Release();	m_pTexture=NULL;	m_iWidth=0;	m_iHeight=0;m_iRequestedWidth=0; m_iRequestedHeight=0;	}
};

//! Direct3D 9.0  Ŭ
/*!
Direct3D 9.0     ֵ,   Ŭȭ Ѱ.
*/
class	CD3D90	:	public Singleton<CD3D90>
{
public:
	enum	MEMORY_TYPE
	{
		MT_VIDEMO=0,
		MT_SYSTEM,
		MT_MANAGE,
		MT_UNKNOWN
	};
private:

	LPDIRECT3D9             m_pD3D;	//! D3D9 ̽
	LPDIRECT3DDEVICE9       m_pd3dDevice;	//! D3D9Device ̽
	D3DPRESENT_PARAMETERS	m_PresentParam;	//! ̽ 
	D3DDISPLAYMODE	m_D3DDM;
	D3DCAPS9	m_Caps;
	bool	m_bIsSoftwareVertexProcessing;
	LPD3DXSPRITE	m_pD3DSprite;	//	2D Ʈ   ȴ.

	D3DXMATRIX	m_matProjection,m_matWorld,m_matView;	//!  Ʈ 

public:

	DWORD	m_dwTotalVideoMemory;
	//!	  ؽ  ޸ .(0 : In video ram, 1 : in system ram 2 : Managed)
	DWORD	m_dwTotalVertexBufferMemorySize[3];	
	//!	  ε  ޸ .
	DWORD	m_dwTotalIndexBufferMemorySize[3];
	//!	  ؽó 
	DWORD	m_dwTotalTextureMemorySize[3];
	//!	  ޸ (ؽ  + ε  + ؽó)
	DWORD	m_dwTotalMemorySize[3];	
public:

	//! , Create()  ȣѴ.
	CD3D90()	{	Create();	}
	//! ı, Destroy()  ȣѴ.
	~CD3D90()	{	Destroy();	}

	//! Create()
	/*!
	ڰ ȣѴ.   ʱȭѴ.
	*/
	bool	Create();
	//! Destroy()
	/*!
	ıڰ ȣѴ.   Release  ʱȭ Ѵ.
	*/
	bool	Destroy();

	//! D3D  ʱȭѴ.
	bool	Init(HWND hWnd,bool bFullScreen=false,int iScreenWidth=1024,int iScreenHeight=768,int iRefershRate=0);	
	//!	D3DDevice  Ѵ.
	LPDIRECT3DDEVICE9	GetDevice()	{	return	m_pd3dDevice;	}	
	D3DCAPS9*	GetCaps()	{	return	&m_Caps;	}
	D3DDISPLAYMODE*	GetDM()	{	return	&m_D3DDM;	}
	LPD3DXSPRITE GetSprite()	{	return	m_pD3DSprite;	}

	//!    ؽĸ Ѵ.
	bool	SetTexture(LPDIRECT3DTEXTURE9 pTexture,int iStage);	

	//!   ˸. 
	bool	BeginScene(DWORD dwClearColor);	
	//!  Ḧ ˸.
	bool	EndScene();
	//!  ȭ鿡 Ÿ 
	bool	Present();	

	//!   Ѵ.
	bool	SetBackBufferSize(int iWidth,int iHeight);	
	//!   Ѵ.
	POINT	GetBackBufferSize();	

	//! ȭ  Ѵ.(/)
	float	GetScreenSizeAspect();	

	//!  Ʈ Ѵ.
	void	InitMatrices();	
	//!  D3D ȯ  Ѵ.
	void	SetupRenderEnv();	

	//!  Ʈ Ѵ.
	D3DXMATRIX*	GetProjectionMatrix()	{	return	&m_matProjection;	}	
	//!  Ʈ Ѵ.
	D3DXMATRIX*	GetWorldMatrix()	{	return	&m_matWorld;	}	
	//!  Ʈ Ѵ.
	D3DXMATRIX*	GetViewMatrix()	{	return	&m_matView;	}	
	//!  ȯ Ʈ Ѵ.
	D3DXMATRIX GetFinalTransfromMatrix();
	D3DXMATRIX	GetFinalTransformUnTransposedMatrix();

	//!  Ʈ Ѵ.
	D3DXMATRIX*	SetViewMatrix(float fEyeX,float fEyeY,float fEyeZ,float fLookAtX,float fLookAtY,float fLookAtZ,float fUpX,float fUpY,float fUpZ);
	void	SetViewMatrix(D3DXMATRIX *pMatrix);
	//!  Ʈ Ѵ.
	void	SetWorldMatrix(D3DXMATRIX *pMatrix);
	//!    Ʈ Ѵ.
	void	SetOrthoProjectionMatrix(float fW,float fH,float fZn,float fZf);
	//!     Ư Ѵ.
	void	SetPerspectiveProjectionMatrix(float fFovY,float fAspect,float fZn,float fZf);
	void	SetProjectionMatrix(D3DXMATRIX *pMatrix);
	//! vsh  εϰ  ̴ Ѵ.
	HRESULT	CreateVSFromCompiledFile(D3DVERTEXELEMENT9 *pDecl,LPDIRECT3DVERTEXDECLARATION9 *pDeclaration,LPDIRECT3DVERTEXSHADER9 *pShader,TCHAR *strShaderFilename);
	//! vsh  εϰ  ̴ Ѵ.
	HRESULT	CreateVSFromCompiledFile(LPDIRECT3DVERTEXSHADER9 *pShader,TCHAR *strShaderFilename);

	//!	 ۸ Ѵ.
	HRESULT	CreateVertexBuffer(DWORD	dwLength,DWORD dwUsage,DWORD dwFVF,D3DPOOL Pool,IDirect3DVertexBuffer9** ppVertexBuffer,HANDLE *pSharedHandle);
	//!	ؽ ۸ Ѵ.
	bool	ReleaseVertexBuffer(IDirect3DVertexBuffer9* pVertexBuffer);
	//!	ε ۸ Ѵ.
	HRESULT	CreateIndexBuffer(DWORD	dwLength,DWORD dwUsage,D3DFORMAT Format,D3DPOOL Pool,IDirect3DIndexBuffer9** ppIndexBuffer,HANDLE *pSharedHandle);
	//!	ε ۸ Ѵ.
	bool	ReleaseIndexBuffer(IDirect3DIndexBuffer9* pIndexBuffer);
	//*	Ϸκ ؽó εѴ.  ޼ҵ带   ؽó Managed  ޸𸮷 ȴ.
	HRESULT CreateTextureFromFile(LPDIRECT3DTEXTURE9 *ppTexture,char *strFilename);	
	//*	Ϸκ ؽó εѴ.  ɼ    ִ.
	HRESULT	CreateTextureFromFileEx(LPDIRECT3DTEXTURE9 *ppTexture,char *strFilename,DWORD dwMipLevels,DWORD dwUsage,D3DFORMAT Format,D3DPOOL Pool,DWORD dwFilter,DWORD dwMipFilter,D3DCOLOR ColorKey,D3DXIMAGE_INFO *pSrcInfo,PALETTEENTRY *pPalette);
	//*	ؽó Ѵ.
	bool	ReleaseTexture(LPDIRECT3DTEXTURE9 pTexture);


	//*	D3DSURFACE_DESC  , ش ǥ ޸ Ÿ԰ ޸  Ѵ.
	bool	GetSurfaceMemoryInfo(const D3DSURFACE_DESC &SrcDesc,DWORD &dwTotalMemory,MEMORY_TYPE &MemType);

	//!	ϵ      Ѵ.
	int	GetMaxBoneCount();
public:

	//! ش ũ ؽĸ ؼ, Texture  ҴѴ.
	bool	CreateTexture(int iWidth,int iHeight,CTexture &Texture);	


};
#define g_D3D90 CD3D90::GetSingleton()	//	for my convinience

#endif