#ifndef _GRAPHIC_OBJECT_h
#define _GRAPHIC_OBJECT_h

#include "Common.H"
#include "Singleton.H"
#include <vector>
using namespace std;

class	CXMLResource;
class	CTextureResource;
class	CSoundResource;

class	CFrameData
{
	
};

class	CActionData
{
	enum	ACTION_TYPE
	{
		AT_SINGLEIMAGE=0,
		AT_ANIMATION
	};

	ACTION_TYPE	m_Type;
	
	char	m_strActionName;
	DWORD	m_dwActionID;
	
public:

	CActionData()
	{
		m_Type = AT_SINGLEIMAGE;
	}
	~CActionData()
	{
	}

	

};

class	CGraphicObjectData
{
	float	m_fVersion;
	int	m_iTotalAction;
	int	m_iTotalTexture;
	int	m_iTotalSound;

	char	m_strXMLFileName[MAX_RES_FILENAME_LENGTH+1];
	CXMLResource	*m_pDescXML;

	CTextureResource	**m_ppaTextureResource;
	CSoundResource	**m_ppaSoundResource;

	CActionData	*m_pActions;

	DWORD	m_dwRefCount;

public:

	CGraphicObjectData()	{	Create();	}
	~CGraphicObjectData()	{	Destroy();	}

	bool	LoadFromXML(char *strXMLFileName,bool bLoadImmediately);	

	char*	GetXMLFileName()	{	return	m_strXMLFileName;	}	

	void	AddRefCount()	{	m_dwRefCount++;	}
	void	MinusRefCount()	{	if(m_dwRefCount>0) m_dwRefCount--;	}
	DWORD	GetRefCount()	{	return	m_dwRefCount;	}

private:

	void	Create();
	void	Destroy();

	bool	SetDataFromXML();
};
typedef vector<CGraphicObjectData*> GODataVector;
typedef GODataVector::iterator GODataVectorItor;

class	CGraphicObjectDataMgr	:	public	Singleton<CGraphicObjectDataMgr>
{
	GODataVector	m_vGOData;

public:

	CGraphicObjectDataMgr()	{	Create();	}
	~CGraphicObjectDataMgr()	{	Destroy();	}

	CGraphicObjectData*	CreateNewGOData(char *strGODataXMLFile,bool bLoadImmediately);
	CGraphicObjectData*	GetGOData(char *strGODataXMLFile);
	bool	ReleaseGOData(CGraphicObjectData *pGOData);

private:

	void	Create();
	void	Destroy();

};
#define g_GODataMgr CGraphicObjectDataMgr::GetSingleton()	//	for my convinience


class	CGraphicObject
{


};

#endif