#ifndef _GAMEENGINE_INTERFACE_H
#define _GAMEENGINE_INTERFACE_H

#include <windows.h>
#include <list>
#include "ResourceManager.H"

using namespace std;

class	CCard;

typedef list<CCard*> CardList;
typedef CardList::iterator CardListItor;

class	CXMLResource;
class	CCard	
{
	CardList	m_ChildCard;

	//	Card Position(left,top)
	POINT	m_ptPosition;

	//	Card Size(width,height)
	POINT	m_ptSize;

	bool	m_bRender,m_bGetInput,m_bProcess;

	CXMLResource	*m_pCardDescXML;

	CTextureResource	*m_pBGImage;
	CMusicResource	*m_pBGM;

public:

	CCard()	{	Create();	}
	virtual	~CCard()	{	Destroy();	}

	virtual	void	SetCardDescXML(char *strXMLFileName);

	virtual	bool	Process();
	virtual	bool	Render();
	virtual bool	GetInput();

	bool	PushCardBack(CCard *pChild);
	bool	PushCardFront(CCard *pChild);
	bool	ReleaseCard(CCard *pChild);
	int	GetTotalChildNumber();
	
	void	RenderEnable(bool bEnable)	{	m_bRender = bEnable;	}
	void	ProcessEnable(bool bEnable)	{	m_bProcess = bEnable;	}
	void	GetInputEnbale(bool bEnable)	{	m_bGetInput = bEnable;	}

	bool	IsRenderEnable()	{	return	m_bRender;	}
	bool	IsProcessEnable()	{	return	m_bProcess;	}
	bool	IsGetInputEnable()	{	return	m_bGetInput;	}

	//	Ʒ ټ ǲ ޼ óϴ ޼ҵ
	//	true   , ش ǲ ޼ ȴ.
	//	false   , ش  ޼  ī ޵ȴ.
	virtual	bool	KeyDown(int iKeyID);
	virtual	bool	MouseDown(BYTE byButton,int iMouseX,int iMouseY);	
	virtual	bool	MouseUp(BYTE byButton,int iMouseX,int iMouseY);
	virtual	bool	MouseDClick(BYTE byButton,int iMouseX,int iMouseY);
	virtual	bool	MouseWheel(int iAmount,int iMouseX,int iMouseY);

private:

	bool	Create();
	bool	Destroy();	

	bool	ReleaseAllChild();

	virtual	void	BuildCardFromXML();
};

#endif