#include <windows.H>
#include "GameEngine.H"
#include "Interface.H"
#include "SFXML.H"
#include	<crtdbg.h>
#include "GraphicObject.H"
#include "Direct3D.H"

CGameEngine* CGameEngine::ms_Singleton;
bool	CGameEngine::Create()
{
#ifdef	_MSC_VER
	_CrtSetDbgFlag( _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) |
		_CRTDBG_LEAK_CHECK_DF/* | _CRTDBG_DELAY_FREE_MEM_DF */);
#endif

	m_hWnd=0;
	m_bActive=false;
	m_iWidth=0;
	m_iHeight=0;
	m_iRefreshRate=0;
	m_bFullScreen=false;
	m_bFinish=false;

	m_pResourceMgr = new CResourceMgr;
	m_pD3D90 = new CD3D90;
	m_pGODataMgr = new CGraphicObjectDataMgr;

	return	true;
}
bool	CGameEngine::Destroy()
{

	delete m_pResourceMgr;
	delete m_pD3D90;
	delete m_pGODataMgr;

	return	true;
}
LRESULT CALLBACK CGameEngine::WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch(uMsg)
	{
	case	WM_KEYDOWN:
		{
			CGameEngine::GetSingleton().GetBaseCard()->KeyDown(wParam);
		}
		break;
    case WM_CLOSE:
        DestroyWindow( hWnd );
        return 0;
    
    case WM_DESTROY:
        PostQuitMessage(0);
        return 0L;
	}
    return DefWindowProc( hWnd, uMsg, wParam, lParam );
}
void	CGameEngine::ProcessCard()
{
	m_BaseCard.Process();
}
void	CGameEngine::RenderCard()
{
	
	m_pD3D90->BeginScene(0);

	m_BaseCard.Render();

	m_pD3D90->EndScene();
	m_pD3D90->Present();
}

bool	CGameEngine::InitEngine(LPSTR strTitle,HINSTANCE hInst,LPSTR strCmdLine,int iWidth,int iHeight,bool bFullScreen,int iRefreshRate)
{
    // Register the window class
    WNDCLASS wndClass = { CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS, WndProc, 0, 0, hInst,
                          LoadIcon( hInst, IDI_APPLICATION),
                          LoadCursor(NULL, IDC_ARROW), 
                          (HBRUSH)GetStockObject(WHITE_BRUSH), NULL,
                          TEXT("GameEngineDX90Window") };

    RegisterClass( &wndClass );
 
    // Create our main window
    m_hWnd = CreateWindow( TEXT("GameEngineDX90Window"),
                           strTitle,
                           WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
                           CW_USEDEFAULT, iWidth,iHeight, 0L, 0L, hInst, 0L );

    ShowWindow( m_hWnd, SW_SHOWNORMAL );
    UpdateWindow( m_hWnd );



	if(!m_pD3D90->Init(m_hWnd,bFullScreen,iWidth,iHeight,iRefreshRate))
	{
		MessageBox(NULL,"Direct3D 9.0 Initialized failed!","",MB_OK);
		return false;
	}

	m_bActive = true;


	//g_GODataMgr.CreateNewGOData("Data/GraphicObject/TitleCardGO.XML",true);


	return	true;
}
int	CGameEngine::StartEngine()
{


    BOOL bGotMsg;
    MSG  msg;
    PeekMessage( &msg, NULL, 0U, 0U, PM_NOREMOVE );


    while( WM_QUIT != msg.message  && m_bFinish == false)
    {

		bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE );

        if( bGotMsg )
        {
            TranslateMessage( &msg );
            DispatchMessage( &msg );
        }
        else
        {
			ProcessCard();

			if(m_bActive)
			{
				RenderCard();
			}
			else
				Sleep(100);
        }
    }   



	return msg.wParam;
}
