#ifndef _GAME_ENGINE_H
#define _GAME_ENGINE_H

#include "Singleton.H"
#include "Interface.H"

class	CResourceMgr;
class	CD3D90;
class	CGraphicObjectDataMgr;

class	CGameEngine	:	public	Singleton<CGameEngine>
{
	HWND	m_hWnd;
	bool	m_bActive;

	int	m_iWidth,m_iHeight,m_iRefreshRate;
	bool	m_bFullScreen;

	CResourceMgr *m_pResourceMgr;
	CD3D90	*m_pD3D90;
	CGraphicObjectDataMgr	*m_pGODataMgr;

	CCard	m_BaseCard;

	bool	m_bFinish;

public:

	CGameEngine() { Create(); }
	~CGameEngine() { Destroy(); }

	bool	InitEngine(LPSTR strTitle,HINSTANCE hInst,LPSTR strCmdLine,int iWidth,int iHeight,bool bFullScreen,int iRefreshRate);
	int	StartEngine();

	void	ProcessCard();
	void	RenderCard();

	CCard*	GetBaseCard()	{	return	&m_BaseCard;	}

	HWND	GetWnd()	{	return	m_hWnd;	}
	bool	IsActive()	{	return	m_bActive; }
	bool	IsFullScreen()	{	return	m_bFullScreen;	}
	int	GetWidth()	{	return	m_iWidth;	}
	int	GetHeight()	{	return	m_iHeight;	}
	int	GetRefreshRate()	{	return	m_iRefreshRate;	}

	void	FinishEngine()	{	m_bFinish = true;	}

private:

	bool	Destroy();
	bool	Create();

	static LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

};

#endif